import { SimpleTreeViewProps } from '@mui/x-tree-view/SimpleTreeView';
import { RichTreeViewProps } from '@mui/x-tree-view/RichTreeView';
import { TreeViewBaseItem } from '@mui/x-tree-view/models';
import { TreeItem2Props } from '@mui/x-tree-view/TreeItem2';

type TreeViewProps = SimpleTreeViewProps<true>;
declare const TreeView: ({ children, ...rest }: TreeViewProps) => JSX.Element;

type DynamicTreeViewProps = RichTreeViewProps<TreeViewBaseItem, true>;
declare const DynamicTreeView: ({ children, slots, ...rest }: DynamicTreeViewProps) => JSX.Element;

interface TreeItemProps extends TreeItem2Props {
    truncate?: boolean;
}
declare const TreeItem: ({ children, label, slots, slotProps, truncate, ...rest }: TreeItemProps) => JSX.Element;

interface JsonViewerProps extends Omit<TreeViewProps, 'children'> {
    /** Data to be rendered, can be most valid javascript objects, some uncommon types may not by fully supported - like cyclical objects, proxies, symbols as keys. */
    data: Record<string, unknown>;
}

export { DynamicTreeView, type DynamicTreeViewProps, type JsonViewerProps, TreeItem, type TreeItemProps, TreeView, type TreeViewProps };
